import Flutter
import UIKit
import Foundation
import Cloudinary


public class SwiftCloudnaryFlutterPlugin: NSObject, FlutterPlugin {

    let channel: FlutterMethodChannel
    var result: FlutterResult!
    var fileData: NSMutableData = NSMutableData()
    var dataTask: URLSessionDataTask?
    var expectedContentLength = 0
    var progress: Float = 0.0
    var timer = Timer()
    
    init(channel: FlutterMethodChannel) {
        self.channel = channel
    }

  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "cloudnary_flutter", binaryMessenger: registrar.messenger())
      let instance = SwiftCloudnaryFlutterPlugin(channel: channel)
//      instance.prepareForInterfaceBuilder()

    registrar.addMethodCallDelegate(instance, channel: channel)
//      registrar.a

  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      if call.method == "uploadToCloudnary"{

          let tempData = call.arguments as? [String: AnyObject]
          
          let cloudName = tempData?["cloudName"] as? String ?? ""
          let path = tempData?["path"] as? String ?? ""
          let api = tempData?["api"] as? String ?? ""
          let apiSecret = tempData?["apiSecret"] as? String ?? ""

          let publicId = tempData?["publicId"] as? String ?? ""
          let notificationUrl = tempData?["notificationUrl"] as? String ?? ""
        
          var data = Data()
          
          if path.contains("http"){
              data = try! Data(contentsOf: URL(string: path)!)
          }else{
              data = try! Data(contentsOf: URL(fileURLWithPath: path))
          }
          
//          do {
//          if channel.
             let config = CLDConfiguration(cloudName: cloudName, apiKey: api, apiSecret: apiSecret, secure: true)
             let cloudinary = CLDCloudinary(configuration: config)
//          }catch{
//              print(error)
//          }

          let params = CLDUploadRequestParams()
              .setPublicId(publicId)
            .setNotificationUrl(notificationUrl)
          params.setParam("background_removal", value: "cloudinary_ai")

          let request = cloudinary.createUploader().signedUpload(
            data: data, params: params)
          
          request.response { res, error in
              result(res?.url)
              print(res?.url ?? "")
          }
          
      }
  }
}
